//
//  Bitmap.m
//  MandelOpper
//
//  Created by Ken Anderson on 4/29/12.
//  Copyright (c) 2012 University of Colorado, Boulder. All rights reserved.
//

#import "Bitmap.h"

@implementation Bitmap

@synthesize width = _width;
@synthesize height = _height;

- (id) initWithWidth: (NSUInteger) width height: (NSUInteger) height {
    if (self = [super init]) {
        _width = width;
        _height = height;
        
        _buffer = malloc(_width * _height * 4);
        
        // fill buffer with a semitransparent gray color
        memset(_buffer, 0x55, _width * _height * 4);
    }
    return self;
}

- (void) dealloc {
    free(_buffer);
}

- (NSBitmapImageRep *) imageRep {
    return [[NSBitmapImageRep alloc]
           initWithBitmapDataPlanes: &_buffer
           pixelsWide: self.width
           pixelsHigh: self.height
           bitsPerSample: 8
           samplesPerPixel: 4
           hasAlpha: YES
           isPlanar: NO
           colorSpaceName: NSDeviceRGBColorSpace
           bytesPerRow: self.width * 4
           bitsPerPixel: 32];
}

- (unsigned char *) baseAddressForLine: (NSUInteger) line {
    unsigned char *addr = _buffer + (line * self.width * 4);
    return addr;
}


@end
